local _, ns = ...
local B, C, L, DB = unpack(ns)
local P = B:GetModule("Plus")
local Bar = B:GetModule("Actionbar")
-----------------
-- Credit: ElvUI
-----------------
local FadeFrames = {
	["GlobalFade_ActionBar"] = {
		"NDui_ActionBar1",
		"NDui_ActionBar2",
		"NDui_ActionBar3",
		"NDui_ActionBar4",
		"NDui_ActionBar5",
		"NDui_CustomBar",
		"NDui_ActionBarPet",
		"NDui_ActionBarStance",
	},
	["GlobalFade_UnitFrame"] = {
		"oUF_Player",
		"oUF_Pet",
	},
}

function P:FadeBlingTexture(cooldown, alpha)
	if not cooldown then return end
	cooldown:SetBlingTexture(alpha > 0.5 and [[Interface\Cooldown\star4]] or P.Blank)
end

function P:FadeBlings(alpha)
	for _, button in pairs(Bar.buttons) do
		P:FadeBlingTexture(button.cooldown, alpha)
	end
end

function P:Fade_OnEnter()
	if not P.fadeParent.mouseLock then
		P:UIFrameFadeIn(P.fadeParent, .2, P.fadeParent:GetAlpha(), 1)
		P:FadeBlings(1)
	end
end

function P:Fade_OnLeave()
	if not P.fadeParent.mouseLock then
		P:UIFrameFadeOut(P.fadeParent, P.fadeDuration, P.fadeParent:GetAlpha(), P.fadeAlpha)
		P:FadeBlings(P.fadeAlpha)
	end
end

function P:FadeParent_OnEvent()
	if UnitCastingInfo("player") or UnitChannelInfo("player") or UnitExists("target")
	or UnitAffectingCombat("player") or (UnitHealth("player") ~= UnitHealthMax("player")) then
		self.mouseLock = true
		P:UIFrameFadeIn(self, .2, self:GetAlpha(), 1)
		P:FadeBlings(1)
	else
		self.mouseLock = false
		P:UIFrameFadeOut(self, P.fadeDuration, self:GetAlpha(), P.fadeAlpha)
		P:FadeBlings(P.fadeAlpha)
	end
end

function P:HookFadeFrame()
	for key, frames in pairs(FadeFrames) do
		if NDuiPlusDB[key] then
			for _, v in pairs(frames) do
				local f = _G[v]
				if f then
					f:SetParent(P.fadeParent)
					f:HookScript("OnEnter", P.Fade_OnEnter)
					f:HookScript("OnLeave", P.Fade_OnLeave)
				end
			end
		end
	end

	if not NDuiPlusDB["GlobalFade_ActionBar"] then return end

	for _, button in ipairs(Bar.buttons) do
		button:HookScript("OnEnter", P.Fade_OnEnter)
		button:HookScript("OnLeave", P.Fade_OnLeave)	
	end
end

function P:GlobalFade()
	if not NDuiPlusDB["GlobalFade"] then return end

	P.fadeAlpha = NDuiPlusDB["GlobalFadeAlpha"] or .1
	P.fadeDuration = NDuiPlusDB["GlobalFadeDuration"] or .3

	P.fadeParent = CreateFrame("Frame", "NDui_Plus_Fader", _G.UIParent, "SecureHandlerStateTemplate")
	RegisterStateDriver(P.fadeParent, 'visibility', '[petbattle] hide; show')
	P.fadeParent:SetAlpha(P.fadeAlpha)
	P.fadeParent:SetScript("OnEvent", P.FadeParent_OnEvent)

	if NDuiPlusDB["GlobalFade_Combat"] then
		P.fadeParent:RegisterEvent("PLAYER_REGEN_DISABLED")
		P.fadeParent:RegisterEvent("PLAYER_REGEN_ENABLED")
	end

	if NDuiPlusDB["GlobalFade_Target"] then
		P.fadeParent:RegisterEvent("PLAYER_TARGET_CHANGED")
	end

	if NDuiPlusDB["GlobalFade_Cast"] then
		P.fadeParent:RegisterUnitEvent("UNIT_SPELLCAST_START", "player")
		P.fadeParent:RegisterUnitEvent("UNIT_SPELLCAST_STOP", "player")
		P.fadeParent:RegisterUnitEvent("UNIT_SPELLCAST_CHANNEL_START", "player")
		P.fadeParent:RegisterUnitEvent("UNIT_SPELLCAST_CHANNEL_STOP", "player")
	end

	if NDuiPlusDB["GlobalFade_Health"] then
		P.fadeParent:RegisterUnitEvent("UNIT_HEALTH", "player")
	end

	C_Timer.After(.5, P.HookFadeFrame)
end