local _, ns = ...
local B, C, L, DB = unpack(ns)
local P = B:GetModule("Plus")
local cr, cg, cb = DB.r, DB.g, DB.b

function P:MythicDungeonTools()
	if not IsAddOnLoaded("MythicDungeonTools") then return end

	local MDT = _G.MDT

	local Buttons = {
		"sidePanelNewButton",
		"sidePanelRenameButton",
		"sidePanelImportButton",
		"sidePanelExportButton",
		"sidePanelDeleteButton",
		"LinkToChatButton",
		"ClearPresetButton",
		"LiveSessionButton",
		"MDIButton",
	}

	local styled
	hooksecurefunc(MDT, "ShowInterface", function()
		if styled then return end

		local frame = MDT.main_frame
		frame.HelpButton.Ring:Hide()

		local closeButton = frame.closeButton
		B.ReskinClose(closeButton, frame.sidePanel, -7, -7)
		closeButton:SetSize(20, 20)

		local maximize = frame.maximizeButton
		B.ReskinMinMax(maximize)
		maximize.MaximizeButton:SetSize(20, 20)
		maximize.MinimizeButton:SetSize(20, 20)

		for _, v in pairs(Buttons) do
			local button = frame[v] and frame[v].frame
			if button and button.__bg and button.__gradient then
				button:HookScript("OnEnter", P.Button_OnEnter)
				button:HookScript("OnLeave", P.Button_OnLeave)
			end
		end

		local progressBar = frame.sidePanel.ProgressBar.Bar
		B.StripTextures(progressBar)
		progressBar:SetStatusBarTexture(DB.normTex)
		B.CreateBDFrame(progressBar, .25)

		styled = true
	end)
end