local _, ns = ...
local B, C, L, DB = unpack(ns)
local P = B:GetModule("Plus")
local S = B:GetModule("Skins")

local _G = getfenv(0)

function P:RematchTitleButton(close)
	B.StripTextures(self, close and 0 or 1)
	local bg = B.CreateBDFrame(self, .25)
	bg:SetPoint("TOPLEFT", 7, -7)
	bg:SetPoint("BOTTOMRIGHT", -7, 7)
end

function P:Rematch()
	if not IsAddOnLoaded("Rematch") then return end

	-- RematchFrame
	--[[
	local frame = RematchFrame
	B.StripTextures(frame)
	B.SetBD(frame)
	B.StripTextures(frame.TitleBar)

	P.RematchTitleButton(frame.TitleBar.CloseButton, true)
	P.RematchTitleButton(frame.TitleBar.LockButton)
	P.RematchTitleButton(frame.TitleBar.MinimizeButton)
	P.RematchTitleButton(frame.TitleBar.SinglePanelButton)

	for _, tab in ipairs(frame.PanelTabs.Tabs) do
		B.ReskinTab(tab)
	end
	--]]

	hooksecurefunc(RematchOptionPanel.funcs, "PanelTabsToRight", function()
		if not RematchSettings.PanelTabsToRight then
			RematchFrame.PanelTabs:SetPoint("TOPLEFT", RematchFrame, "BOTTOMLEFT", -6, 1)
		end
	end)

	S.RematchIcon(RematchToolbar.FindBattle)

	-- RematchLoadedTeamPanel
	local teamPanel = RematchLoadedTeamPanel
	P.RematchTitleButton(teamPanel.Footnotes.Close, true)
	P.RematchTitleButton(teamPanel.Footnotes.Maximize)

	-- RematchMiniQueue
	B.StripTextures(RematchMiniQueue.Status)
	B.StripTextures(RematchMiniQueue.Top)
	S.RematchFilter(RematchMiniQueue.Top.QueueButton)

	-- RematchMiniPanel
	local miniPanel = RematchMiniPanel
	B.StripTextures(miniPanel.Background)
	B.CreateBDFrame(miniPanel, .25)

	B.StripTextures(miniPanel.Target)
	B.CreateBDFrame(miniPanel.Target, 0)

	local loadButton = miniPanel.Target.LoadButton
	loadButton:DisableDrawLayer("BACKGROUND")
	B.Reskin(loadButton)

	for _, button in ipairs(miniPanel.Target.Pets) do
		S.RematchIcon(button)
	end

	local flyout = miniPanel.Flyout
	flyout:SetBackdrop(nil)
	for i = 1, 2 do
		S.RematchIcon(flyout.Abilities[i])
	end

	hooksecurefunc(miniPanel, "Update", function(self)
		if not self then return end

		for _, button in ipairs(miniPanel.Pets) do
			if not button.styled then
				S.RematchIcon(button)
				S.RematchXP(button.HP)
				S.RematchXP(button.XP)

				for i = 1, 3 do
					S.RematchIcon(button.Abilities[i])
				end

				button.styled = true
			end

			local icon = button.Icon
			local iconBorder = button.IconBorder
			if icon.bg then
				if RematchSettings.HideRarityBorders then
					icon.bg:SetBackdropBorderColor(0, 0, 0)
				else
					icon.bg:SetBackdropBorderColor(iconBorder:GetVertexColor())
				end
			end
		end
	end)

	-- ALPTCConfigs
	local function reskinALPTInput(self)
		self:SetBackdrop(nil)
		self:DisableDrawLayer("BACKGROUND")
		P.ReskinInput(self)
		self.bg:SetInside()
	end

	local function reskinALPTDropDown(self)
		B.StripTextures(self)
		local bg = B.CreateBDFrame(self, 0)
		bg:SetPoint("TOPLEFT", 15, -4)
		bg:SetPoint("BOTTOMRIGHT", 110, 8)
		B.CreateGradient(bg)

		local down = self.Button
		down:ClearAllPoints()
		down:SetPoint("RIGHT", bg, 0, 0)
		B.ReskinArrow(down, "down")
		down:SetSize(20,20)
	end

	local config = RematchDialog.ALPTCConfigs
	if config then
		for i = 1, 3 do
			B.ReskinCheck(config["Breed"..i])
			B.ReskinCheck(config["NoAlt"..i])
			B.ReskinCheck(config["Highest"..i])
			B.ReskinCheck(config["UseGroup"..i])

			-- reskinALPTInput(config["HP"..i])
			-- reskinALPTInput(config["MinLvl"..i])
			-- reskinALPTInput(config["FilterHP"..i.."_1"])
			-- reskinALPTInput(config["FilterHP"..i.."_2"])
			-- reskinALPTInput(config["FilterAttack"..i.."_1"])
			-- reskinALPTInput(config["FilterAttack"..i.."_2"])
			-- reskinALPTInput(config["FilterSpeed"..i.."_1"])
			-- reskinALPTInput(config["FilterSpeed"..i.."_2"])

			reskinALPTDropDown(config["Groups"..i])
		end

		B.ReskinCheck(config.Disable)
	end

	local function delayFunc()
		B.StripTextures(miniPanel.Target.ModelBorder)
		B.CreateBDFrame(miniPanel.Target.ModelBorder, 0)

		local ALPTBtn = _G.ALPTRematchOptionButton
		if ALPTBtn then
			ALPTBtn:ClearAllPoints()
			ALPTBtn:SetParent(RematchJournal)
			ALPTBtn:SetPoint("TOPRIGHT", RematchJournal, "TOPRIGHT", -230, -28)
			ALPTBtn:SetSize(28, 28)
		end
	end
	C_Timer.After(.5, delayFunc)
end