local _, ns = ...
local B, C, L, DB = unpack(ns)
local P = B:GetModule("Plus")

P.BarConfig = {
	icon = {
		texCoord = DB.TexCoord,
		points = {
			{"TOPLEFT", C.mult, -C.mult},
			{"BOTTOMRIGHT", -C.mult, C.mult},
		},
	},
	flyoutBorder = {file = ""},
	flyoutBorderShadow = {file = ""},
	border = {file = ""},
	normalTexture = {
		file = DB.textures.normal,
		texCoord = DB.TexCoord,
		color = {.3, .3, .3},
		points = {
			{"TOPLEFT", 0, 0},
			{"BOTTOMRIGHT", 0, 0},
		},
	},
	flash = {file = DB.textures.flash},
	pushedTexture = {file = DB.textures.pushed},
	checkedTexture = {file = DB.textures.checked},
	highlightTexture = {
		file = "",
		points = {
			{"TOPLEFT", C.mult, -C.mult},
			{"BOTTOMRIGHT", -C.mult, C.mult},
		},
	},
	cooldown = {
		points = {
			{"TOPLEFT", 0, 0},
			{"BOTTOMRIGHT", 0, 0},
		},
	},
	name = {
		font = {DB.Font[1], DB.Font[2]+1, DB.Font[3]},
		points = {
			{"BOTTOMLEFT", 0, 0},
			{"BOTTOMRIGHT", 0, 0},
		},
	},
	hotkey = {
		font = {DB.Font[1], DB.Font[2]+1, DB.Font[3]},
		points = {
			{"TOPRIGHT", 0, -0.5},
			{"TOPLEFT", 0, -0.5},
		},
	},
	count = {
		font = {DB.Font[1], DB.Font[2]+1, DB.Font[3]},
		points = {
			{"BOTTOMRIGHT", 2, 0},
		},
	},
	buttonstyle = {file = ""},
}

function P:tdGUI()
	local GUI = LibStub and LibStub('tdGUI-1.0', true)
	local DropMenu = GUI and GUI:GetClass("DropMenu")

	if DropMenu then
		hooksecurefunc(DropMenu, "Constructor", P.ReskinTooltip)
		hooksecurefunc(DropMenu, "Toggle", P.ReskinTooltip)
	end
end

function P:InterfaceOptionsFrame()
	B.ReskinScroll(InterfaceOptionsFrameAddOnsListScrollBar)
end

function P:Skins()
	self:InterfaceOptionsFrame()
	self:Ace3()
	self:tdGUI()
	self:InboxMailBag()
	self:TinyInspect()
	self:TradeLog()
	self:ButtonForge()
	self:WowLua()
	self:PremadeGroupsFilter()
	self:tdBattlePetScript()
	self:Rematch()
	self:WorldQuestsList()
	self:WeakAuras()
	self:MogPartialSets()
	self:ls_Toasts()
	self:WhisperPop()
	self:Immersion()
	self:MeetingStone()
	self:TomeOfTeleportation()
	self:MythicDungeonTools()
end
